/*
 *  Copyright (C) 2008 Patrik Gornicz, Gornicz_P (at) hotmail (dot) com.
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef ENTITY_H
#define ENTITY_H

#include <bear/Vector2.h>
using namespace bear;


/// ***** Header Class *****

class Entity
{
  protected:
    Entity(const Vector2&);

  public:
    virtual ~Entity();

    virtual void update(float) = 0;
    virtual void draw() const = 0;

    const Vector2& positionRaw() const;
    const Vector2& velocityRaw() const;

  protected:
    Vector2 m_position;
    Vector2 m_velocity;
};

#endif // ENTITY_H
